Subject: fix for vulnerability CVE-2008-3577 for OpenTTD 0.1.0 - 0.3.3 (Buffer overflow in "-g" parameter handling)
From: OpenTTD developer team <info@openttd.org>
Origin: backport, https://github.com/OpenTTD/OpenTTD/commit/6860193
Bug:

Buffer overflow allowing local users to possibly execute arbitrary code via a
large filename supplied to the “-g” parameter in the ttd_main function.

NOTE: it is unlikely that this issue would cross privilege boundaries in
typical environments.


Index: ttd.c
===================================================================
--- ttd.c
+++ ttd.c
@@ -458,6 +458,6 @@
 		case 'g':
 			if (mgo.opt) {
-				strcpy(_file_to_saveload, mgo.opt);
+				ttd_strlcpy(_file_to_saveload, mgo.opt, sizeof(_file_to_saveload));
 				_switch_mode = SM_LOAD;
 			} else {
 				_switch_mode = SM_NEWGAME;

